unit DoomCelRep;
/////// *************************************************** //////////////
///     ******                                       ****** //////////////
///     ****** by Phoenix and Aliast, 3DOPlanet.RU   ****** //////////////
///     ******---------------------------------------****** //////////////
///                      DOOM_CEL_RESTORER (2015)
///     ***************************************************///////////////
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ScrX: TEdit;
    ScrY: TEdit;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function GetShapeWidth(data:integer):integer;
    function GetShapeHeight(data:integer):integer;
    function GetSwap32(data:integer):integer;
    function PacketMode:boolean;
    procedure RestoreCel;
  end;

var
  Form1: TForm1;
  CELfile: TFileStream;
  DoomFile: TfileStream;
  MemStream: TMemoryStream; ///    DoomFile   
  x_num: integer;      // 
  x_count: integer; ///     -
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var 
 I: integer;
 Signature1,Signature2: integer;
 PDAToffs:integer;
 PLUToffs: integer;
 DataInt: integer;
 Strange,origi: integer;
 PDATbuf: array of byte;
 PLUTbuf: array of byte;
 CCBbuf: array of byte;
 returnhere, curpos: integer;
 PlutSecSize: integer;
 Pdatsecsize: integer;
 PRE0,PRE1:integer;
 Xsize,Ysize: integer;
 swpdat: integer;
 retried: boolean;
label retryit;
begin
 OpenDialog1.Execute;
 //Signature:=
 if OpenDialog1.FileName<>'' then
  begin
    //ShowMessage(OpenDialog1.Files.Text);
   for I := 0 to OpenDialog1.Files.Count-1 do
    BEGIN
    try
     origi:=0;
     retried:=false;
     DoomFile:= TFileStream.Create(OpenDialog1.Files.Strings[i],fmOpenRead);
     Strange:=0;
     DoomFile.Seek(0,0);
     DoomFile.Read(Strange,4); ///  
     // Strange:=0;
retryit:
     Signature1:=0;
     DoomFile.Seek(origi,0);
     DoomFile.Read(Signature1,1);
     DoomFile.Seek(origi+4,0);
     DoomFile.Read(Signature2,4);
     if (Signature2<>0) and ((Signature1<>$47) and
        (Signature1<>$67)) then
                       begin
                         if (GetSwap32(Strange)<$1ff){DoomFile.Size} and
                          (retried=false) then 
                             begin
                              //DoomFile.Seek(GetSwap32(Strange),0);
                              //Origi:=GetSwap32(Strange);
                              //retried:=true;
                              //goto retryit;
                              PacketMode;
                             end;
                         DoomFile.Free;
                         continue;
                       end;
     DoomFile.Read(PDAToffs,4);
                              asm
                                  mov eax,PDAToffs
                                       bswap eax
                                  mov PDAToffs,eax
                              end;

     returnhere:= DoomFile.Position;
     DoomFile.Position:= DoomFile.Position+PDAToffs;
     Pdatsecsize:= DoomFile.Size-DoomFile.Position;
     SetLength(PDATbuf,DoomFile.Size-DoomFile.Position);

     DoomFile.ReadBuffer(PDATbuf[0],DoomFile.Size-DoomFile.Position);
     DoomFile.Position:= returnhere;
     DoomFile.Read(PLUToffs,4);
                             asm
                                  mov eax,PLUToffs
                                       bswap eax
                                  mov PLUToffs,eax
                              end;
     if PLUToffs <> 0 then
     begin
     PlutSecSize:= PDAToffs-PLUToffs; ///  PLUTa
     curpos:= DoomFile.Position+PLUToffs;
     DoomFile.Position:=CurPos;
     SetLength(PLUTbuf,PlutSecSize-4);
     DoomFile.Read(PLUTbuf[0],PlutSecSize-4);
     end;
     curpos:= $3C;

     DoomFile.Seek(origi,0);
     SetLength(CCBbuf,curpos);
     DoomFile.Read(CCBbuf[0],curpos);

     CELfile:= TFileStream.Create(OpenDialog1.Files.Strings[i]+'.CEL',fmCreate);
     DataInt:=541213507;
     CELfile.Write(DataInt,4); /// eto 'CCB '
     swpdat:= GetSwap32($50{PDAToffs});
     CELfile.Write(swpdat,4);
     DataInt:=0;
     CELfile.Write(DataInt,4);
     CELfile.Write(CCBbuf[0],curpos);

     ///      
     DoomFile.Position:= curpos-8;
     DoomFile.Read(PRE0,4);
                              asm
                                  mov eax,PRE0
                                       bswap eax
                                  mov PRE0,eax
                              end;
     DoomFile.Position:= curpos-4;
     DoomFile.Read(PRE1,4);
                              asm
                                  mov eax,PRE1
                                       bswap eax
                                  mov PRE1,eax
                              end;

     Xsize:= GetShapeWidth(PRE1);
     Ysize:= GetShapeHeight(PRE0);
                              asm
                                  mov eax,Xsize
                                       bswap eax
                                  mov Xsize,eax
                              end;
                              asm
                                  mov eax,Ysize
                                       bswap eax
                                  mov Ysize,eax
                              end;
     ////    
     //swpdat:=GetSwap32(Xsize);
     CELfile.Write(Xsize,4);
     //swpdat:=GetSwap32(Ysize);
     CELfile.Write(Ysize,4);

     ///   PLUT
     if PLUToffs <> 0 then
     begin
     DataInt:=1414876240;  ///  PLUT
     CELfile.Write(DataInt,4);
     swpdat:= GetSwap32(PlutSecSize+8);
     CELfile.Write(swpdat,4);
     DataInt:=GetSwap32($10);
     CELfile.Write(DataInt,4);
     CELfile.Write(PLUTbuf[0],PlutSecSize-4);
     end;


     ///   PDAT
     DataInt:=1413563472;  ///  PDAT
     CELfile.Write(DataInt,4);
     DataInt:=Pdatsecsize+8;
     swpdat:=GetSwap32(DataInt);
     CELfile.Write(swpdat,4);
     CELfile.Write(PDATbuf[0],Pdatsecsize);
     ///finish
     except
        Memo1.Lines.Add('error_'+OpenDialog1.Files.Strings[i]);
        continue;
     end;

     try
      if CELfile<>nil then CELfile.Free;
     except

     end;
     try
      if DoomFile<>nil then DoomFile.Free;
     except

     end;
    END;
    ShowMessage('Finished');
  end;
end;

function TForm1.PacketMode:boolean;
var
 blockoffs: integer; ///     
 blockoffs_next: integer;
 block_size: integer;
 signature_found:boolean;
 offs_list: TStringList;
 Buffer: array of byte;
begin
 // vb
 result:=false;
 signature_found:=false;
 //offs_list:= TStringList.Create;
 ///      
 x_num:=0;
 x_count:=0;
 while not(signature_found) do
 Begin
  try
   DoomFile.Seek(x_num,0);
   DoomFile.Read(blockoffs,4);
   DoomFile.Read(blockoffs_next,4);
   blockoffs:=GetSwap32(blockoffs);
   if (blockoffs and $FFFF0000)=0 then
             begin
               blockoffs_next:=GetSwap32(blockoffs_next);
               if (blockoffs_next and $FFFF0000)=0
                then
                 block_size:=blockoffs_next-blockoffs ///    
               else
                 block_size:=DoomFile.Size-blockoffs;
               MemStream:= TMemoryStream.Create;
               MemStream.SetSize(block_size);
               SetLength(Buffer,block_size);
               DoomFile.Position:= blockoffs;
               DoomFile.ReadBuffer(Buffer[0],block_size);
               MemStream.WriteBuffer(Buffer[0],block_size);
               RestoreCel;
               MemStream.Free;
             end
   else
    begin
      result:=true;
      break;
    end;
   inc(x_num,4);
   inc(x_count);
   except
   break;
  end;
 End;

end;

procedure TForm1.RestoreCel;
var 
 I: integer;
 Signature1,Signature2: integer;
 PDAToffs:integer;
 PLUToffs: integer;
 DataInt: integer;
 Strange,origi: integer;
 PDATbuf: array of byte;
 PLUTbuf: array of byte;
 CCBbuf: array of byte;
 returnhere, curpos: integer;
 PlutSecSize: integer;
 Pdatsecsize: integer;
 PRE0,PRE1:integer;
 Xsize,Ysize: integer;
 swpdat: integer;
 retried: boolean;
begin
  BEGIN
    try
     origi:=0;
     Strange:=0;
     MemStream.Seek(0,0);
     MemStream.Read(Strange,4); ///  
     // Strange:=0;

     Signature1:=0;
     MemStream.Seek(origi,0);
     MemStream.Read(Signature1,1);
     MemStream.Seek(origi+4,0);
     MemStream.Read(Signature2,4);
     {if (Signature2<>0) and ((Signature1<>$47) and
        (Signature1<>$67)) then
                       begin
                         if (GetSwap32(Strange)<$50)
                           then
                             begin
                              //DoomFile.Seek(GetSwap32(Strange),0);
                              //Origi:=GetSwap32(Strange);
                              //retried:=true;
                              //goto retryit;
                              PacketMode;
                             end;
                         DoomFile.Free;
                         continue;
                       end; }
     MemStream.Read(PDAToffs,4);
                              asm
                                  mov eax,PDAToffs
                                       bswap eax
                                  mov PDAToffs,eax
                              end;

     returnhere:= MemStream.Position;
     MemStream.Position:= MemStream.Position+PDAToffs;
     Pdatsecsize:= MemStream.Size-MemStream.Position;
     SetLength(PDATbuf,MemStream.Size-MemStream.Position);

     MemStream.ReadBuffer(PDATbuf[0],MemStream.Size-MemStream.Position);
     MemStream.Position:= returnhere;
     MemStream.Read(PLUToffs,4);
                             asm
                                  mov eax,PLUToffs
                                       bswap eax
                                  mov PLUToffs,eax
                              end;
     if PLUToffs <> 0 then
     begin
     PlutSecSize:= PDAToffs-PLUToffs; ///  PLUTa
     curpos:= MemStream.Position+PLUToffs;
     MemStream.Position:=CurPos;
     SetLength(PLUTbuf,PlutSecSize-4);
     MemStream.Read(PLUTbuf[0],PlutSecSize-4);
     end;
     curpos:= $3C;

     MemStream.Seek(origi,0);
     SetLength(CCBbuf,curpos);
     MemStream.Read(CCBbuf[0],curpos);

     CELfile:= TFileStream.Create(DoomFile.FileName+'_'+inttostr(x_count)+'.CEL',fmCreate);
     DataInt:=541213507;
     CELfile.Write(DataInt,4); /// eto 'CCB '
     swpdat:= GetSwap32($50{PDAToffs});
     CELfile.Write(swpdat,4);
     DataInt:=0;
     CELfile.Write(DataInt,4);
     CELfile.Write(CCBbuf[0],curpos);

     ///      
     MemStream.Position:= curpos-8;
     MemStream.Read(PRE0,4);
                              asm
                                  mov eax,PRE0
                                       bswap eax
                                  mov PRE0,eax
                              end;
     MemStream.Position:= curpos-4;
     MemStream.Read(PRE1,4);
                              asm
                                  mov eax,PRE1
                                       bswap eax
                                  mov PRE1,eax
                              end;

     Xsize:= GetShapeWidth(PRE1);
     Ysize:= GetShapeHeight(PRE0);
                              asm
                                  mov eax,Xsize
                                       bswap eax
                                  mov Xsize,eax
                              end;
                              asm
                                  mov eax,Ysize
                                       bswap eax
                                  mov Ysize,eax
                              end;
     ////    
     //swpdat:=GetSwap32(Xsize);
     CELfile.Write(Xsize,4);
     //swpdat:=GetSwap32(Ysize);
     CELfile.Write(Ysize,4);

     ///   PLUT
     if PLUToffs <> 0 then
     begin
     DataInt:=1414876240;  ///  PLUT
     CELfile.Write(DataInt,4);
     swpdat:= GetSwap32(PlutSecSize+8);
     CELfile.Write(swpdat,4);
     DataInt:=GetSwap32($10);
     CELfile.Write(DataInt,4);
     CELfile.Write(PLUTbuf[0],PlutSecSize-4);
     end;


     ///   PDAT
     DataInt:=1413563472;  ///  PDAT
     CELfile.Write(DataInt,4);
     DataInt:=Pdatsecsize+8;
     swpdat:=GetSwap32(DataInt);
     CELfile.Write(swpdat,4);
     CELfile.Write(PDATbuf[0],Pdatsecsize);
     ///finish
     except
        Memo1.Lines.Add('error_'+OpenDialog1.Files.Strings[i]);
        //continue;
     end;

     try
      if CELfile<>nil then CELfile.Free;
     except

     end;
    
    END;
end;


function TForm1.GetShapeWidth(data: Integer):integer;
begin
 result:= (data and $7FF)+1;
end;

function TForm1.GetShapeHeight(data: Integer):integer;
begin
 result:= (((data shr 6) AND $3FF) + 1);
end;

function TForm1.GetSwap32(data: Integer):integer;
begin
                               asm
                                  mov eax,data
                                       bswap eax
                                  mov data,eax
                              end;
   result:=data;
end;

end.
